BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Summary:        Xwork IOC Framework
Name:           xwork
Version:        1.2.1
Release:        alt1_1jpp1.7
Epoch:          0
License:        Apache Software License modified
URL:            http://www.opensymphony.com/xwork/
Group:          Development/Java
Source0:        xwork-1.2.1.tar.bz2
Source1:        xwork-LICENSE.txt
Patch0:         xwork-1.2.1-build_xml.patch
Patch1:         xwork-1.2.1-osbuild_xml.patch
Patch2:         xwork-1.2.1-temp.patch
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-junit >= 0:1.6
BuildRequires: ant-nodeps >= 0:1.6
BuildRequires: junit
BuildRequires: ivy
BuildRequires: mockobjects
BuildRequires: mockobjects-jdk1.4
BuildRequires: mockobjects-alt-jdk1.4
BuildRequires: mockobjects-jdk1.4-j2ee1.4
BuildRequires: dom4j
BuildRequires: easymock
BuildRequires: easymock-classextension
BuildRequires: velocity
BuildRequires: javamail
BuildRequires: ognl
BuildRequires: oscore
BuildRequires: jakarta-commons-attributes
BuildRequires: jakarta-commons-cli
BuildRequires: jakarta-commons-codec
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-commons-logging
BuildRequires: log4j
BuildRequires: rife-continuations
BuildRequires: cglib
BuildRequires: spring-aop
BuildRequires: spring-beans
BuildRequires: spring-context
BuildRequires: spring-core
BuildRequires: spring-mock
BuildRequires: spring-web
BuildRequires: xml-commons-apis
Requires: ognl
Requires: oscore
Requires: jakarta-commons-logging
Requires: junit
Requires: rife-continuations
Requires: spring-beans
Requires: spring-context
Requires: spring-web
Requires: xml-commons-apis
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
XWork is an command-pattern framework that is used to power 
WebWork as well as other applications. XWork provides an 
Inversion of Control container, a powerful expression 
language, data type conversion, validation, and pluggable 
configuration. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-junit junit"

pushd lib/bootstrap
ln -sf $(build-classpath commons-cli) .
ln -sf $(build-classpath commons-codec) .
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath ivy) .
popd
pushd lib/build
ln -sf $(build-classpath dom4j) .
ln -sf $(build-classpath easymock-classextension) .
ln -sf $(build-classpath easymock) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath log4j) .
ln -sf $(build-classpath mockobjects-j2ee1.4) .
ln -sf $(build-classpath mockobjects-alt) .
ln -sf $(build-classpath mockobjects) .
ln -sf $(build-classpath mockobjects-core) .
ln -sf $(build-classpath velocity) .
popd
pushd lib/default
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath javamail/mailapi) javamail.jar
ln -sf $(build-classpath ognl) .
ln -sf $(build-classpath oscore) .
ln -sf $(build-classpath rife-continuations) .
ln -sf $(build-classpath xml-commons-apis) .
popd
pushd lib/spring
ln -sf $(build-classpath cglib-nodep) .
ln -sf $(build-classpath commons-attributes-api) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath spring/aop) .
ln -sf $(build-classpath spring/beans) .
ln -sf $(build-classpath spring/context) .
ln -sf $(build-classpath spring/core) .
ln -sf $(build-classpath spring/mock) .
ln -sf $(build-classpath spring/web) .
popd

ant -Dskip.ivy=true jar javadocs junit.report

%install

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 build/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp docs/*.dtd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
rm docs/*.dtd 

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp %{SOURCE1} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/LICENSE.txt

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_datadir}/%{name}-%{version}
%{_javadir}/*.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}

%files manual
%doc %{_docdir}/*

%changelog
* Sat Jan 26 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.2.1-alt1_1jpp1.7
- converted from JPackage by jppimport script

